.TH HG GRAFT  "" "" ""
.SH NAME
hg graft \- copy changes from other branches onto the current branch
.\" Man page generated from reStructuredText.
.
.SH SYNOPSIS
.sp
.nf
.ft C
hg graft [OPTION]... [\-r REV]... REV...
.ft P
.fi
.SH DESCRIPTION
.sp
This command uses Mercurial\(aqs merge logic to copy individual
changes from other branches without merging branches in the
history graph. This is sometimes known as \(aqbackporting\(aq or
\(aqcherry\-picking\(aq. By default, graft will copy user, date, and
description from the source changesets.
.sp
Changesets that are ancestors of the current revision, that have
already been grafted, or that are merges will be skipped.
.sp
If \-\-log is specified, log messages will have a comment appended
of the form:
.sp
.nf
.ft C
(grafted from CHANGESETHASH)
.ft P
.fi
.sp
If \-\-force is specified, revisions will be grafted even if they
are already ancestors of, or have been grafted to, the destination.
This is useful when the revisions have since been backed out.
.sp
If a graft merge results in conflicts, the graft process is
interrupted so that the current merge can be manually resolved.
Once all conflicts are addressed, the graft process can be
continued with the \-c/\-\-continue option.
.sp
The \-c/\-\-continue option reapplies all the earlier options.
.sp
The \-\-base option exposes more of how graft internally uses merge with a
custom base revision. \-\-base can be used to specify another ancestor than
the first and only parent.
.sp
The command:
.sp
.nf
.ft C
hg graft \-r 345 \-\-base 234
.ft P
.fi
.sp
is thus pretty much the same as:
.sp
.nf
.ft C
hg diff \-\-from 234 \-\-to 345 | hg import
.ft P
.fi
.sp
but using merge to resolve conflicts and track moved files.
.sp
The result of a merge can thus be backported as a single commit by
specifying one of the merge parents as base, and thus effectively
grafting the changes from the other side.
.sp
It is also possible to collapse multiple changesets and clean up history
by specifying another ancestor as base, much like rebase \-\-collapse
\-\-keep.
.sp
The commit message can be tweaked after the fact using commit \-\-amend .
.sp
For using non\-ancestors as the base to backout changes, see the backout
command and the hidden \-\-parent option.
.sp
The experimental \-\-to option allows grafting a revision in\-memory,
independent of the working copy. Merge conflicts are not currently
supported, and the operation will be aborted if the configured tool
cannot handle the conflicts that might be encountered.
.sp
As the operation is performed in\-memory, the on\-disk files will not be
modified, and some hooks might not be run.
.sp
Examples:
.INDENT 0.0
.IP \(bu 2
.
copy a single change to the stable branch and edit its description:
.sp
.nf
.ft C
hg update stable
hg graft \-\-edit 9393
.ft P
.fi
.IP \(bu 2
.
graft a range of changesets with one exception, updating dates:
.sp
.nf
.ft C
hg graft \-D "2085::2093 and not 2091"
.ft P
.fi
.IP \(bu 2
.
continue a graft after resolving conflicts:
.sp
.nf
.ft C
hg graft \-c
.ft P
.fi
.IP \(bu 2
.
show the source of a grafted changeset:
.sp
.nf
.ft C
hg log \-\-debug \-r .
.ft P
.fi
.IP \(bu 2
.
show revisions sorted by date:
.sp
.nf
.ft C
hg log \-r "sort(all(), date)"
.ft P
.fi
.IP \(bu 2
.
backport the result of a merge as a single commit:
.sp
.nf
.ft C
hg graft \-r 123 \-\-base 123^
.ft P
.fi
.IP \(bu 2
.
land a feature branch as one changeset:
.sp
.nf
.ft C
hg up \-cr default
hg graft \-r featureX \-\-base "ancestor(\(aqfeatureX\(aq, \(aqdefault\(aq)"
.ft P
.fi
.UNINDENT
.sp
See \%\fBhg help revisions\fP\: for more about specifying revisions.
.sp
Returns 0 on successful completion, 1 if there are unresolved files.
.SH OPTIONS
.INDENT 0.0
.TP
.BI \-r,  \-\-rev \ <REV[+]>
.
revisions to graft
.TP
.BI \-\-base \ <REV>
.
base revision when doing the graft merge (ADVANCED)
.TP
.BI \-\-to \ <VALUE>
.
graft to this destination, in\-memory (EXPERIMENTAL)
.TP
.B \-c,  \-\-continue
.
resume interrupted graft
.TP
.B \-\-stop
.
stop interrupted graft
.TP
.B \-\-abort
.
abort interrupted graft
.TP
.B \-e,  \-\-edit
.
invoke editor on commit messages
.TP
.B \-\-log
.
append graft info to log message
.TP
.B \-\-no\-commit
.
don\(aqt commit, just apply the changes in working directory
.TP
.B \-f,  \-\-force
.
force graft
.TP
.B \-D,  \-\-currentdate
.
record the current date as commit date
.TP
.B \-U,  \-\-currentuser
.
record the current user as committer
.TP
.BI \-d,  \-\-date \ <DATE>
.
record the specified date as commit date
.TP
.BI \-u,  \-\-user \ <USER>
.
record the specified user as committer
.TP
.BI \-t,  \-\-tool \ <TOOL>
.
specify merge tool
.TP
.B \-n,  \-\-dry\-run
.
do not perform actions, just print output
.UNINDENT
.sp
[+] marked option can be specified multiple times
.\" Generated by docutils manpage writer.
.\" 
.
